#include "StdAfx.h"
#include "montgomery.h"

//==============================================================
//			RXgN^
//==============================================================
montgomery::montgomery(void)
{
}

//==============================================================
//			fXgN^
//==============================================================
montgomery::~montgomery(void)
{
}

//==============================================================
//			Set Modulo
//--------------------------------------------------------------
//	
//		BigInt	N		@iModuloj
//	Ԓl
//						
//	
//		S_NVׂ̈ɁA\N', R, R2vZB
//		Calculate N' R, R2 for the montgomery reduction.
//			m	<=	Int( log2( N ) )		c Ñrbg
//			R	<=	2^(m+1)					c 2̗ݏ抎Nȏ̒l
//			R2	<=	R * R mod N
//			NN'		-1 mod R	ƂȂN'ZoB
//	
//		N͑fł鎖B	iGCD( N , R )==1𖞂j
//		ȉ𖞂ȂRƑfɂȂ炸AS_NVłȂj
//	s wI t
//		R͑fĂA2݂̂ł̂ŁA
//		N͑fɁA2܂܂ȂlA܂fłΗǂB
//==============================================================
void	montgomery::Set_Modulo(BigInt* N)
{
				BigInt	t		=	0;	//N'vZp	(t mod R)R-1
				BigInt	i		=	1;	//N'vZp	
				char*	ptT;
	unsigned	int		szN		=	N->Get_Byte_Length();
	unsigned	int		m		=	N->Get_Bit_Length();

						m_m		=	m;

						m_R_1	=	1;
						m_R_1	<<=	m;
						m_R_1	-=	1;

						m_R2	=	1;
						m_R2	<<= m*2;
						m_R2	%=	*N;

						m_N		=	*N;
						m_invN	=	0;

	//NN'		 -1 mod R	́A
	//NN'		R-1 mod R	ł邩Ȁ𖞂N'TB

	//R2^mȂ̂ŁA-1Ɖʃrbg͑S"1"ɂȂB
	//ȉ́AZ NN'R-1 ɂāAQi̕MZ N' ߂R[hB
	//ʂ1bittZAʃrbgS"1"ɂȂ悤ɁA
	//while()\ɂāAN*2^niKIɉZB
	i.resize(szN);
	m_invN.resize(szN);
	t.resize(szN+1);
	ptT = t.Get_Ptr();				//
	while(m>0){						//R-1̃rbgJԂi܂ÑrbgjB
		if((ptT[0] & 0x01) == 0){	//ŉʃrbg"0"A
			BigInt_Add(&t, N);		//111...1<2>ɂ邽߂ɁANZi{N<<ځj
			BigInt_Or(&m_invN, &i);	//ẐŁAN'̂̌1ɂB
		}
		BigInt_Shr1(&t);			//{̓VtgȂǁAvŽ̂߁B
		BigInt_Shl1(&i);			//݂̌
		m--;
	}
}

//==============================================================
//		Montgomery reduction	iSE_NVj
//--------------------------------------------------------------
//	
//		BigInt&	result	ʂIuWFNgւ̃|C^
//		BigInt	T		S_NV鐮̃IuWFNg
//	Ԓl
//						
//	
//		t	<=	( T + ( TN' mod R ) N ) / R
//		if t>=N then t-= N
//	
//		0  T  2N-1	ł鎖B
//==============================================================
void	montgomery::MR(BigInt* result, BigInt T)
{
//	*result = (T + (T * m_invN & m_R_1) * m_N) >> m_m;

	BigInt_Mul(result, T, m_invN);
	*result	&=	m_R_1;
	*result	*=	m_N;
	*result	+=	T;
	*result	>>=	m_m;

	if(*result >= m_N){
		*result	-=	m_N;
	}
}

//==============================================================
//			ZiMULj
//--------------------------------------------------------------
//	
//		BigInt&	_Dst	ʂ̐lIuWFNg̃|C^
//		BigInt	_Src1	鐔̃IuWFNgiQƁj
//		int		_Src2	鐔̃IuWFNgiQƁj
//	Ԓl
//						
//	
//		_Dst  _Src1 ~ _Src2 mod N
//	
//		ȉ̏𖞂
//		0  src1  N-1
//		0  src2  N-1
//==============================================================
void	montgomery::Mul(BigInt* dst, BigInt& src1, BigInt& src2)
{
	BigInt_Mul(dst, src1, src2);
	MR(dst, *dst);
	BigInt_Mul(dst, *dst, m_R2);
	MR(dst, *dst);
}

//==============================================================
//			ݏioCi[@FʌvZj
//--------------------------------------------------------------
//	
//		BigInt*	_Result	ʂ̐lIuWFNg̃|C^
//		BigInt	_Src1	ݏ悳鐔̃IuWFNgiQƁj
//		BigInt&	_Src2	ݏ悷鐔̃IuWFNgiQƁj
//	Ԓl
//						
//	
//		_Result  _Src1 sup _Src2 mod N
//	
//		ȉ̏𖞂
//		0  _Src1  N-1
//		0  _Src2
//==============================================================
void	montgomery::Power(BigInt* _Result, BigInt& _Src1, BigInt& _Src2)
{
	//搔̏ꍇ
	BigInt	temp	= _Src2;
	BigInt	dst		= _Src1;

	//----------
	//S\ɕϊ
	dst	*=	m_R2;
	MR(&dst, dst);
	MR(_Result, m_R2);

	//----------
	//S̈ŌvZ
	while (temp.Chk_Zero() == false){
		if(BigInt_Shr1(&temp) != 0){
			*_Result *= dst;
			MR(_Result, *_Result);
			break;
		}
		dst *= dst;
		MR(&dst, dst);
	};

	while (temp.Chk_Zero() == false){
		dst *= dst;
		MR(&dst, dst);
		if(BigInt_Shr1(&temp) != 0){
			*_Result *= dst;
			MR(_Result, *_Result);
		}
	};

	//----------
	//S\tϊ
	MR(_Result, *_Result);
}
